/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// TimeProperInterval A temporal entity with non-zero extent or duration, i.e. for which the value of the beginning and end are different
type TimeProperInterval interface {
	TimeInterval
	timeIntervalEqualsSingleTimeProperInterval
	timeIntervalStartsSingleTimeProperInterval
	timeIntervalContainsSingleTimeProperInterval
	timeIntervalDisjointSingleTimeProperInterval
	timeIntervalMeetsSingleTimeProperInterval
	timeIntervalAfterSingleTimeProperInterval
	timeIntervalOverlapsSingleTimeProperInterval
	timeIntervalFinishedBySingleTimeProperInterval
	timeIntervalOverlappedBySingleTimeProperInterval
	timeIntervalBeforeSingleTimeProperInterval
	timeIntervalDuringSingleTimeProperInterval
	timeIntervalStartedBySingleTimeProperInterval
	timeIntervalFinishesSingleTimeProperInterval
	timeIntervalInSingleTimeProperInterval
	timeIntervalMetBySingleTimeProperInterval
	IsTimeProperInterval() bool // indicates base class
}

// sTimeProperInterval A temporal entity with non-zero extent or duration, i.e. for which the value of the beginning and end are different
type sTimeProperInterval struct {
	sTimeInterval
	propTimeIntervalEqualsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalStartsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalContainsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalDisjointBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalMeetsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalAfterBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalOverlapsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalFinishedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalOverlappedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalBeforeBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalDuringBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalStartedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalFinishesBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalInBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
	propTimeIntervalMetByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval
}

// NewTimeProperInterval creates a new TimeProperInterval
func (mod *Model) NewTimeProperInterval(iri string) (ret TimeProperInterval, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sTimeProperInterval{}
	pc := propCommon{iri: iri, typ: "TimeProperInterval", model: mod}
	res.propCommon = pc
	mod.addTimeProperInterval(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sTimeProperInterval) makeMaps() {
	res.sTimeInterval.makeMaps()
	return
}

// addTimeProperInterval adds TimeProperInterval to model
func (mod *Model) addTimeProperInterval(res TimeProperInterval) {
	mod.mTimeProperInterval[res.IRI()] = res
	mod.addTimeInterval(res)
	return
}

// TimeProperInterval returns all resources with given prefix
func (mod *Model) TimeProperInterval(prefix string) (res []TimeProperInterval) {
	for i := range mod.mTimeProperInterval {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mTimeProperInterval[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sTimeProperInterval) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "http://www.w3.org/2006/time#intervalEquals":
		res.propTimeIntervalEqualsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.removeObject(obj)
	case "http://www.w3.org/2006/time#intervalStarts":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalStarts.IRI() == v.IRI() {
				res.SetTimeIntervalStarts(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalContains":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalContains.IRI() == v.IRI() {
				res.SetTimeIntervalContains(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalDisjoint":
		res.propTimeIntervalDisjointBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.removeObject(obj)
	case "http://www.w3.org/2006/time#intervalMeets":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalMeets.IRI() == v.IRI() {
				res.SetTimeIntervalMeets(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalAfter":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalAfter.IRI() == v.IRI() {
				res.SetTimeIntervalAfter(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalOverlaps":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalOverlaps.IRI() == v.IRI() {
				res.SetTimeIntervalOverlaps(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalFinishedBy":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalFinishedBy.IRI() == v.IRI() {
				res.SetTimeIntervalFinishedBy(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalOverlappedBy":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalOverlappedBy.IRI() == v.IRI() {
				res.SetTimeIntervalOverlappedBy(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalBefore":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalBefore.IRI() == v.IRI() {
				res.SetTimeIntervalBefore(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalDuring":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalDuring.IRI() == v.IRI() {
				res.SetTimeIntervalDuring(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalStartedBy":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalStartedBy.IRI() == v.IRI() {
				res.SetTimeIntervalStartedBy(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalFinishes":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalFinishes.IRI() == v.IRI() {
				res.SetTimeIntervalFinishes(nil)
			}
		}
	case "http://www.w3.org/2006/time#intervalIn":
		res.propTimeIntervalInBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.removeObject(obj)
	case "http://www.w3.org/2006/time#intervalMetBy":
		if v, ok := obj.(TimeProperInterval); ok {
			if res.timeIntervalMetBy.IRI() == v.IRI() {
				res.SetTimeIntervalMetBy(nil)
			}
		}
	default:
		res.sTimeInterval.RemoveObject(obj, prop)
	}
	return
}

// isTimeProperInterval indicates base class
func (res *sTimeProperInterval) IsTimeProperInterval() bool {
	return true
}

// SetTimeIntervalStarts is setter of If a proper interval T1 is intervalStarts another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is before the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalStarts(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalStarts != nil {
			if res.timeIntervalStarts.IRI() != in.IRI() {
				temp := res.timeIntervalStarts
				res.timeIntervalStarts = in
				temp.SetTimeIntervalStartedBy(nil)
				in.SetTimeIntervalStartedBy(res)
			}
		} else {
			res.timeIntervalStarts = in
			in.SetTimeIntervalStartedBy(res)
		}
	} else {
		if res.timeIntervalStarts != nil {
			temp := res.timeIntervalStarts
			res.timeIntervalStarts = in
			temp.SetTimeIntervalStartedBy(nil)
		}
	}
	return
}

// SetTimeIntervalContains is setter of If a proper interval T1 is intervalContains another proper interval T2, then the beginning of T1 is before the beginning of T2, and the end of T1 is after the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalContains(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalContains != nil {
			if res.timeIntervalContains.IRI() != in.IRI() {
				temp := res.timeIntervalContains
				res.timeIntervalContains = in
				temp.SetTimeIntervalDuring(nil)
				in.SetTimeIntervalDuring(res)
			}
		} else {
			res.timeIntervalContains = in
			in.SetTimeIntervalDuring(res)
		}
	} else {
		if res.timeIntervalContains != nil {
			temp := res.timeIntervalContains
			res.timeIntervalContains = in
			temp.SetTimeIntervalDuring(nil)
		}
	}
	return
}

// SetTimeIntervalMeets is setter of If a proper interval T1 is intervalMeets another proper interval T2, then the end of T1 is coincident with the beginning of T2.
func (res *sTimeProperInterval) SetTimeIntervalMeets(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalMeets != nil {
			if res.timeIntervalMeets.IRI() != in.IRI() {
				temp := res.timeIntervalMeets
				res.timeIntervalMeets = in
				temp.SetTimeIntervalMetBy(nil)
				in.SetTimeIntervalMetBy(res)
			}
		} else {
			res.timeIntervalMeets = in
			in.SetTimeIntervalMetBy(res)
		}
	} else {
		if res.timeIntervalMeets != nil {
			temp := res.timeIntervalMeets
			res.timeIntervalMeets = in
			temp.SetTimeIntervalMetBy(nil)
		}
	}
	return
}

// SetTimeIntervalAfter is setter of If a proper interval T1 is intervalAfter another proper interval T2, then the beginning of T1 is after the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalAfter(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalAfter != nil {
			if res.timeIntervalAfter.IRI() != in.IRI() {
				temp := res.timeIntervalAfter
				res.timeIntervalAfter = in
				temp.SetTimeIntervalBefore(nil)
				in.SetTimeIntervalBefore(res)
			}
		} else {
			res.timeIntervalAfter = in
			in.SetTimeIntervalBefore(res)
		}
	} else {
		if res.timeIntervalAfter != nil {
			temp := res.timeIntervalAfter
			res.timeIntervalAfter = in
			temp.SetTimeIntervalBefore(nil)
		}
	}
	return
}

// SetTimeIntervalOverlaps is setter of If a proper interval T1 is intervalOverlaps another proper interval T2, then the beginning of T1 is before the beginning of T2, the end of T1 is after the beginning of T2, and the end of T1 is before the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalOverlaps(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalOverlaps != nil {
			if res.timeIntervalOverlaps.IRI() != in.IRI() {
				temp := res.timeIntervalOverlaps
				res.timeIntervalOverlaps = in
				temp.SetTimeIntervalOverlappedBy(nil)
				in.SetTimeIntervalOverlappedBy(res)
			}
		} else {
			res.timeIntervalOverlaps = in
			in.SetTimeIntervalOverlappedBy(res)
		}
	} else {
		if res.timeIntervalOverlaps != nil {
			temp := res.timeIntervalOverlaps
			res.timeIntervalOverlaps = in
			temp.SetTimeIntervalOverlappedBy(nil)
		}
	}
	return
}

// SetTimeIntervalFinishedBy is setter of If a proper interval T1 is intervalFinishedBy another proper interval T2, then the beginning of T1 is before the beginning of T2, and the end of T1 is coincident with the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalFinishedBy(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalFinishedBy != nil {
			if res.timeIntervalFinishedBy.IRI() != in.IRI() {
				temp := res.timeIntervalFinishedBy
				res.timeIntervalFinishedBy = in
				temp.SetTimeIntervalFinishes(nil)
				in.SetTimeIntervalFinishes(res)
			}
		} else {
			res.timeIntervalFinishedBy = in
			in.SetTimeIntervalFinishes(res)
		}
	} else {
		if res.timeIntervalFinishedBy != nil {
			temp := res.timeIntervalFinishedBy
			res.timeIntervalFinishedBy = in
			temp.SetTimeIntervalFinishes(nil)
		}
	}
	return
}

// SetTimeIntervalOverlappedBy is setter of If a proper interval T1 is intervalOverlappedBy another proper interval T2, then the beginning of T1 is after the beginning of T2, the beginning of T1 is before the end of T2, and the end of T1 is after the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalOverlappedBy(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalOverlappedBy != nil {
			if res.timeIntervalOverlappedBy.IRI() != in.IRI() {
				temp := res.timeIntervalOverlappedBy
				res.timeIntervalOverlappedBy = in
				temp.SetTimeIntervalOverlaps(nil)
				in.SetTimeIntervalOverlaps(res)
			}
		} else {
			res.timeIntervalOverlappedBy = in
			in.SetTimeIntervalOverlaps(res)
		}
	} else {
		if res.timeIntervalOverlappedBy != nil {
			temp := res.timeIntervalOverlappedBy
			res.timeIntervalOverlappedBy = in
			temp.SetTimeIntervalOverlaps(nil)
		}
	}
	return
}

// SetTimeIntervalBefore is setter of If a proper interval T1 is intervalBefore another proper interval T2, then the end of T1 is before the beginning of T2.
func (res *sTimeProperInterval) SetTimeIntervalBefore(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalBefore != nil {
			if res.timeIntervalBefore.IRI() != in.IRI() {
				temp := res.timeIntervalBefore
				res.timeIntervalBefore = in
				temp.SetTimeIntervalAfter(nil)
				in.SetTimeIntervalAfter(res)
			}
		} else {
			res.timeIntervalBefore = in
			in.SetTimeIntervalAfter(res)
		}
	} else {
		if res.timeIntervalBefore != nil {
			temp := res.timeIntervalBefore
			res.timeIntervalBefore = in
			temp.SetTimeIntervalAfter(nil)
		}
	}
	return
}

// SetTimeIntervalDuring is setter of If a proper interval T1 is intervalDuring another proper interval T2, then the beginning of T1 is after the beginning of T2, and the end of T1 is before the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalDuring(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalDuring != nil {
			if res.timeIntervalDuring.IRI() != in.IRI() {
				temp := res.timeIntervalDuring
				res.timeIntervalDuring = in
				temp.SetTimeIntervalContains(nil)
				in.SetTimeIntervalContains(res)
			}
		} else {
			res.timeIntervalDuring = in
			in.SetTimeIntervalContains(res)
		}
	} else {
		if res.timeIntervalDuring != nil {
			temp := res.timeIntervalDuring
			res.timeIntervalDuring = in
			temp.SetTimeIntervalContains(nil)
		}
	}
	return
}

// SetTimeIntervalStartedBy is setter of If a proper interval T1 is intervalStarted another proper interval T2, then the beginning of T1 is coincident with the beginning of T2, and the end of T1 is after the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalStartedBy(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalStartedBy != nil {
			if res.timeIntervalStartedBy.IRI() != in.IRI() {
				temp := res.timeIntervalStartedBy
				res.timeIntervalStartedBy = in
				temp.SetTimeIntervalStarts(nil)
				in.SetTimeIntervalStarts(res)
			}
		} else {
			res.timeIntervalStartedBy = in
			in.SetTimeIntervalStarts(res)
		}
	} else {
		if res.timeIntervalStartedBy != nil {
			temp := res.timeIntervalStartedBy
			res.timeIntervalStartedBy = in
			temp.SetTimeIntervalStarts(nil)
		}
	}
	return
}

// SetTimeIntervalFinishes is setter of If a proper interval T1 is intervalFinishes another proper interval T2, then the beginning of T1 is after the beginning of T2, and the end of T1 is coincident with the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalFinishes(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalFinishes != nil {
			if res.timeIntervalFinishes.IRI() != in.IRI() {
				temp := res.timeIntervalFinishes
				res.timeIntervalFinishes = in
				temp.SetTimeIntervalFinishedBy(nil)
				in.SetTimeIntervalFinishedBy(res)
			}
		} else {
			res.timeIntervalFinishes = in
			in.SetTimeIntervalFinishedBy(res)
		}
	} else {
		if res.timeIntervalFinishes != nil {
			temp := res.timeIntervalFinishes
			res.timeIntervalFinishes = in
			temp.SetTimeIntervalFinishedBy(nil)
		}
	}
	return
}

// SetTimeIntervalMetBy is setter of If a proper interval T1 is intervalMetBy another proper interval T2, then the beginning of T1 is coincident with the end of T2.
func (res *sTimeProperInterval) SetTimeIntervalMetBy(in TimeProperInterval) (err error) {
	if in != nil {
		if res.timeIntervalMetBy != nil {
			if res.timeIntervalMetBy.IRI() != in.IRI() {
				temp := res.timeIntervalMetBy
				res.timeIntervalMetBy = in
				temp.SetTimeIntervalMeets(nil)
				in.SetTimeIntervalMeets(res)
			}
		} else {
			res.timeIntervalMetBy = in
			in.SetTimeIntervalMeets(res)
		}
	} else {
		if res.timeIntervalMetBy != nil {
			temp := res.timeIntervalMetBy
			res.timeIntervalMetBy = in
			temp.SetTimeIntervalMeets(nil)
		}
	}
	return
}

// InitFromNode initializes the resource from a graph node
func (res *sTimeProperInterval) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sTimeProperInterval) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "http://www.w3.org/2006/time#intervalEquals":
		res.propTimeIntervalEqualsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#intervalStarts":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalStarts(obj)
		}
	case "http://www.w3.org/2006/time#intervalContains":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalContains(obj)
		}
	case "http://www.w3.org/2006/time#intervalDisjoint":
		res.propTimeIntervalDisjointBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#intervalMeets":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalMeets(obj)
		}
	case "http://www.w3.org/2006/time#intervalAfter":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalAfter(obj)
		}
	case "http://www.w3.org/2006/time#intervalOverlaps":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalOverlaps(obj)
		}
	case "http://www.w3.org/2006/time#intervalFinishedBy":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalFinishedBy(obj)
		}
	case "http://www.w3.org/2006/time#intervalOverlappedBy":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalOverlappedBy(obj)
		}
	case "http://www.w3.org/2006/time#intervalBefore":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalBefore(obj)
		}
	case "http://www.w3.org/2006/time#intervalDuring":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalDuring(obj)
		}
	case "http://www.w3.org/2006/time#intervalStartedBy":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalStartedBy(obj)
		}
	case "http://www.w3.org/2006/time#intervalFinishes":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalFinishes(obj)
		}
	case "http://www.w3.org/2006/time#intervalIn":
		res.propTimeIntervalInBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.init(res.model, pred.Object.Term.String())
	case "http://www.w3.org/2006/time#intervalMetBy":
		if obj, ok := res.model.mTimeProperInterval[pred.Object.Term.String()]; ok {
			res.SetTimeIntervalMetBy(obj)
		}
	default:
		res.sTimeInterval.propsInit(pred)
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sTimeProperInterval) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "http://www.w3.org/2006/time#ProperInterval", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sTimeProperInterval) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.sTimeInterval.propsToGraph(node, g)
	res.propTimeIntervalEqualsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalStartsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalContainsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalDisjointBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalMeetsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalAfterBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalOverlapsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalFinishedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalOverlappedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalBeforeBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalDuringBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalStartedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalFinishesBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalInBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	res.propTimeIntervalMetByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sTimeProperInterval) String() (ret string) {
	ret = res.iri + " " + "TimeProperInterval\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sTimeProperInterval) propsString() (ret string) {
	ret = ""
	ret += res.sTimeInterval.propsString()
	ret += res.propTimeIntervalEqualsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalStartsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalContainsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalDisjointBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalMeetsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalAfterBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalOverlapsBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalFinishedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalOverlappedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalBeforeBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalDuringBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalStartedByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalFinishesBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalInBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	ret += res.propTimeIntervalMetByBaseTimeProperIntervalTypeTimeProperIntervalSingleTimeProperInterval.String()
	return
}


